package lawOfDemeter;
import java.util.*;

public aspect SupplierExecutions {

  // added code
  boolean around(Object target, Supplier s):
    execution(boolean Supplier.contains(Object)) && args(target) && this(s){
      if (s.targets.containsKey(target)) {
        System.out.println(s.targets.get(target));
        return true;
      }
      return false;
  }

  void around(Object target, String i, Supplier s):
    execution(void Supplier.add(Object, String)) && args(target, i) && this(s){
      s.targets.put(target,i);
  }

  void around(Object [] targetlist, String i, Supplier s):
    execution(void Supplier.addAll(Object[], String)) &&
    args(targetlist, i) && this(s){
      for (int k=0; k<targetlist.length; k++)
        s.add(targetlist[k],i);
  }

  String around(org.aspectj.lang.JoinPoint jp):
    execution(protected String Supplier.at(org.aspectj.lang.JoinPoint)) &&
    args(jp){
      return " at "
        + jp.getSourceLocation().getFileName() + ":"
        + jp.getSourceLocation().getLine() + ":"
        + jp.getSourceLocation().getColumn();
  }

  void around(HashMap targets):
    execution(void Supplier.printHashMap(HashMap)) && args(targets){
      System.out.println();
      System.out.println(" elements of targets ");
      Object[] values = targets.values().toArray();
      for (int k=0; k<values.length; k++)
        System.out.println(values[k]);
      System.out.println(" END elements of targets ");
  }

}